/**
 * 演示程序当前的 “注册/登录” 等操作，是基于 “本地存储” 完成的
 * 当您要参考这个演示程序进行相关 app 的开发时，
 * 请注意将相关方法调整成 “基于服务端Service” 的实现。
 **/
(function($, owner) {
	/**
	 * 用户登录
	 **/
	owner.isEmptyObject = function(obj){
    	for (var n in obj) {
        	return false
    	}
    	return true; 
	}; 

	owner.login = function(loginInfo, callback) {
		callback = callback || $.noop;
		loginInfo = loginInfo || {};
		loginInfo.account = loginInfo.account || '';
		loginInfo.password = loginInfo.password || '';
		if (loginInfo.account.length < 3) {
			return callback('账号不能少于3个字符');
		}
		if (loginInfo.password.length < 6) {
			return callback('密码长度不能少于6位');
		}
		var users = JSON.parse(localStorage.getItem('$users') || '[]');
		var authed = users.some(function(user) {
			return loginInfo.account == user.account && loginInfo.password == user.password;
		});
		if (authed) {
			return owner.createState(loginInfo.account,loginInfo.password, callback);
		} else {
			var serv_info = JSON.parse(localStorage.getItem('$serverinfo') || '{}');		
            var dest_url = "http://" + serv_info.ip+":"+serv_info.port+"/app/app_login/";
            //console.log(dest_url);
			$.ajax(dest_url,{
				data:{
					'username':loginInfo.account,
					'password':loginInfo.password
				},
				dataType:'json',
				type:'POST',
				timeout:5000,
				success:function(data){
					js_txt = JSON.parse(data);
					if(js_txt.result==1)
					{
						return owner.createState(loginInfo.account, loginInfo.password,callback);
					}
					else{
						return callback('账号密码无效');
					}
				
				},
				error:function(){	
					return callback('网络无效');
				}
			});
			
		}
	};

	owner.createState = function(name,password, callback) {
		var state = owner.getState();
		state.account = name;
		state.password = password;
		state.token = "token123456789";
		owner.setState(state);
		return callback();
	};

	/**
	 * 新用户注册
	 **/
	owner.reg = function(regInfo, callback) {
		callback = callback || $.noop;
		regInfo = regInfo || {};
		regInfo.password = regInfo.password || '';
		regInfo.email = regInfo.email || '';
	    if (!checkEmail(regInfo.email)) {
			return callback('邮箱无效');
		}
	    
		if (regInfo.password.length < 6) {
			return callback('密码最小长度6个字符');
		}
		
		var serv_info = JSON.parse(localStorage.getItem('$serverinfo') || '{}');		
        var dest_url = "http://" + serv_info.ip+":"+serv_info.port+"/app/app_register/";
        //console.log(dest_url);
		$.ajax(dest_url,{
			data:{
				'email':regInfo.email,
				'password':regInfo.password
			},
			dataType:'json',
			type:'POST',
			timeout:5000,
			success:function(data){
				js_txt = JSON.parse(data);
				console.log(js_txt);
				if(js_txt.result==1)
				{
					return owner.createState(regInfo.account,regInfo.password, callback);
				}
				else{
					return callback('该邮箱已经注册');
				}
			
			},
			error:function(){	
				return callback('无线无效');
			}
		});
			
		//var users = JSON.parse(localStorage.getItem('$users') || '[]');
		//users.push(regInfo);
		//localStorage.setItem('$users', JSON.stringify(users));
		//return callback();
	};

	/**
	 * 获取当前状态
	 **/
	owner.getState = function() {
		var stateText = localStorage.getItem('$state') || "{}";
		return JSON.parse(stateText);
	};

	/**
	 * 设置当前状态
	 **/
	owner.setState = function(state) {
		state = state || {};
		localStorage.setItem('$state', JSON.stringify(state));
		//var settings = owner.getSettings();
		//settings.gestures = '';
		//owner.setSettings(settings);
	};

	var checkEmail = function(email) {
		email = email || '';
		return (email.length > 3 && email.indexOf('@') > -1);
	};

	/**
	 * 找回密码
	 **/
	owner.forgetPassword = function(email, callback) {
		callback = callback || $.noop;
		if (!checkEmail(email)) {
			return callback('无效邮箱');
		}
		
		var serv_info = JSON.parse(localStorage.getItem('$serverinfo') || '{}');		
        var dest_url = "http://" + serv_info.ip+":"+serv_info.port+"/app/app_resend_mail/";
        //console.log(dest_url);
		$.ajax(dest_url,{
			data:{
				'email':email
			},
			dataType:'json',
			type:'POST',
			timeout:5000,
			success:function(data){
				js_txt = JSON.parse(data);
				if(js_txt=="1")
				{
					return callback(null,'密码已经发送到你邮箱');
				}
				else{
					return callback('密码重置失败！');
				}
			
			},
			error:function(){	
				return callback('网络无效');
			}
		});
		
	};

	/**
	 * 获取应用本地配置
	 **/
	owner.setSettings = function(settings) {
		settings = settings || {};
		localStorage.setItem('$settings', JSON.stringify(settings));
	}

	/**
	 * 设置应用本地配置
	 **/
	owner.getSettings = function() {
		var settingsText = localStorage.getItem('$settings') || "{}";
		return JSON.parse(settingsText);
	}
	
	
	owner.setXXXSettings = function(xxx,settings) {
		settings = settings || {};
		localStorage.setItem('$'+xxx, JSON.stringify(settings));
	}

	/**
	 * 设置应用本地配置
	 **/
	owner.getXXXSettings = function(xxx) {
		var settingsText = localStorage.getItem('$'+xxx) || "{}";
		return JSON.parse(settingsText);
	}
	
	owner.loginAgain = function(){
		//app.setState({});
		$.openWindow({
			url: 'login.html',
			id: 'login',
			show: {
				aniShow: 'pop-in'
			},
			waiting: {
				autoShow: false
			}
		});
	}
	
	owner.autologinAgain = function(){
		var state = owner.getState();
		account = state.account;
		password = state.password;
		
		var serv_info = JSON.parse(localStorage.getItem('$serverinfo') || '{}');		
        var dest_url = "http://" + serv_info.ip+":"+serv_info.port+"/app/app_login/";
        //console.log(dest_url);
		$.ajax(dest_url,{
			data:{
				'username':account,
				'password':password
			},
			dataType:'json',
			type:'POST',
			timeout:5000,
			success:function(data){
				js_txt = JSON.parse(data);
				if(js_txt.result==1)
				{
					return owner.createState(loginInfo.account, loginInfo.password,callback);
				}
				else{
					return callback('账号密码无效');
				}
			
			},
			error:function(){	
				return callback('网络无效');
			}
		});
			
	}
	
	owner.switchPage = function(pageID,msDelay){
		setTimeout(function() {
			mui.openWindow({
				id: pageID,
				show: {
					aniShow: 'pop-in'
				},
				waiting: {
					autoShow: false
				}
			});
		}, msDelay);
		
	}
	
	owner.ajax_call = function(destURL,js_data,ajax_type,wait_flag,callback){
		callback = callback || $.noop;
		setTimeout(function() {
			var serv_info = JSON.parse(localStorage.getItem('$serverinfo') || '{}');		
            var dest_url = "http://" + serv_info.ip+":"+serv_info.port+destURL;
            //console.log(dest_url);
            if(wait_flag) plus.nativeUI.showWaiting();     
			mui.ajax(dest_url,{
				data:js_data,
				dataType:'json',
				type:ajax_type,
				timeout:10000,
				success:function(data){
					if(wait_flag) plus.nativeUI.closeWaiting();
					return callback(data);
				},
				error:function(xhr,type,errorThrown){
					if(wait_flag) plus.nativeUI.closeWaiting();
					if(type=="parsererror")
					{
						plus.nativeUI.toast("系统登录已过期退出，请重新登录！");
						owner.autologinAgain();
					}
				}
			});
		}, 0);
	}
	
}(mui, window.app = {}));